<?php

/**
 * ca_cesion_cartera actions.
 *
 * @package    cartera
 * @subpackage ca_cesion_cartera
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class ca_cesion_carteraActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_CESION_CARTERA_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_CESION_CARTERA_V' =>
        array(
            'id_cesion_cartera' => 'id_cesion_cartera',
            'id_debito' => 'id_debito',
            'fecha_proceso' => 'fecha_proceso',
            'usuariolog' => 'usuariolog',
            'fecha_log' => 'fecha_log',
            'saldo' => 'saldo',
            'num_doc' => 'num_doc',
            'id_ts_td' => 'id_ts_td',
            'fecha_doc' => 'fecha_doc',
            'id_mae_ter_ant' => 'id_mae_ter_ant',
            'id_mae_ter' => 'id_mae_ter',
            'observaciones' => 'observaciones',
            'sec_debito' => 'sec_debito',
            'fecha_debito' => 'fecha_debito',
            'num_doc_ant' => 'num_doc_ant',
            'razon_soc_ant' => 'razon_soc_ant',
            'num_doc_nuevo' => 'num_doc_nuevo',
            'razon_soc_nuevo' => 'razon_soc_nuevo',
            'tipo_doc' => 'tipo_doc'
        )
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CA_CESION_CARTERA_V' => array(
            'id_cesion_cartera,a' => array('!=' => array(-1)),
            'id_cesion_cartera,b' => array('=' => array('id_cesion_cartera')),
            'id_debito' => array('=' => array('id_debito')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $query_qualifier = 'DISTINCT'; //eliminar filas repetivas de consulta sql
    protected $fields_orderBy = array(
        'id_debito'
    ); //campos para el ordenamiento de la consulta

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = false;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    /**
     * Metodo para add cesion cartera
     *
     * @param sfWebRequest $request
     */
    public function executeAdd(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        $fecha_proceso = CN_TABLE::fechaSistema();

        /*
         * Manejo de errores
         */
        try {

            /*
             * Variables obligatorias
             */
            $id_debito = $request['id_debito'];
            $id_mae_ter = $request['id_mae_ter'];
            $id_mae_ter_ant = $request['id_mae_ter_ant'];
            $id_ts_td = $request['id_ts_td'];
            //$fecha_proceso = $request['fecha_proceso'];
            $fecha_doc = $request['fecha_doc'];
            $num_doc = $request['num_doc'];
            $observaciones = $request['observaciones'];

            //SACAR EL SALDO
            //sentencia sql
            $sql = <<<EOD
SELECT * FROM CA_DEBITO_SALDOS
WHERE id_debito = $id_debito and id_meses_sal = to_char(sysdate,'mm') and id_anhos_sal = to_char(sysdate,'yyyy')
EOD;

            //ejecuta el sql
            $result = CN_TABLE::executeSQL($sql);
            $saldo = 0;

            if ($result[0]['saldo_actual'] != "") {
                $saldo = $result[0]['saldo_actual'];
            }

            //el username desde qebsafiERP
            $usuario = 'admin';
            if (isset($request['username']) && $request['username'] != '') {
                $usuario = $request['username'];
            }



            //sentencia sql ingresar CA_DEBITO
            $sql = <<<EOD
insert into ca_cesion_cartera (id_cesion_cartera,id_debito,
    fecha_proceso,usuariolog,fecha_log,saldo,num_doc,id_ts_td,fecha_doc,id_mae_ter_ant,
    id_mae_ter,observaciones) 
    values (null,$id_debito,sysdate,'$usuario'
        ,sysdate,
        $saldo,$num_doc,$id_ts_td,to_date('$fecha_doc','yyyy-mm-dd'), $id_mae_ter_ant, $id_mae_ter,'$observaciones')
EOD;

            //ejecuta el sql
            CN_TABLE::executeSQL($sql);


            //SE ACTUALIZA EL TERCERO EN LA TABLA DE DEBITO

            $sql = <<<EOD
    update ca_debito set 
    id_mae_ter = $id_mae_ter
    where id_debito = $id_debito
EOD;

            //ejecuta el sql
            CN_TABLE::executeSQL($sql);

            /**
             * Cesion de los debitos automaticos activos y no cancelados - 20190410
             */
            $sql = <<<EOD
insert into CA_CESION_CARTERA (ID_CESION_CARTERA,
ID_DEBITO,
FECHA_PROCESO,
USUARIOLOG,
FECHA_LOG,
SALDO,
NUM_DOC,
ID_TS_TD,
FECHA_DOC,
ID_MAE_TER_ANT,
ID_MAE_TER,
OBSERVACIONES)

select
null AS ID_CESION_CARTERA,
deb.id_debito as ID_DEBITO,
tab0.FECHA_PROCESO,
tab0.USUARIOLOG,
tab0.FECHA_LOG,
ven.valor as SALDO,
tab0.NUM_DOC,
tab0.ID_TS_TD,
tab0.FECHA_DOC,
tab0.ID_MAE_TER_ANT,
tab0.ID_MAE_TER,
tab0.OBSERVACIONES

from (

    select
    aut.ID_CESION_CARTERA,
    aut.ID_DEBITO,
    aut.FECHA_PROCESO,
    aut.USUARIOLOG,
    aut.FECHA_LOG,
    aut.SALDO,
    aut.NUM_DOC,
    aut.ID_TS_TD,
    aut.FECHA_DOC,
    aut.ID_MAE_TER_ANT,
    aut.ID_MAE_TER,
    aut.OBSERVACIONES,
    
       ROW_NUMBER() OVER (
        partition by aut.id_debito
        ORDER BY aut.id_debito, aut.id_cesion_cartera desc
       ) AS rn
    
    from CA_CESION_CARTERA aut
    
    where
    aut.id_debito = $id_debito

)tab0

left join ca_debito_automatico deb
on deb.id_debito_base = tab0.id_debito

left join ca_vencimientos ven
on deb.id_debito = ven.id_debito

where
tab0.rn = 1
and ven.cancelado = 0 and ven.estado = 1 
EOD;

            //ejecuta el sql
            CN_TABLE::executeSQL($sql);

            $sql = <<<EOD
update ca_debito set 
id_mae_ter = $id_mae_ter
where id_debito in ( SELECT
        id_debito
    FROM ca_debito_automatico where ca_debito_automatico.id_debito_base = $id_debito )
and estado = 1
and id_debito in ( SELECT
            id_debito
        FROM ca_vencimientos where ca_vencimientos.id_debito in ( SELECT
            id_debito
        FROM ca_debito_automatico where ca_debito_automatico.id_debito_base = $id_debito ) and ca_vencimientos.cancelado = 0 ) 
EOD;

            //ejecuta el sql
            CN_TABLE::executeSQL($sql);

            $this->list_data = array();

            /**
             * Llamado INTERFAZ CONTABLE - 20171101
             */
            $this->logMessage("INICIO INTERFAZ CONTABLE CESION CARTERA");

            //Se trae de la configuracion la url que se ha establecido para las interfaces contables
            $arrayAtrib = array();

            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');

            $int = 0;
            foreach ($array as $routeName => $routeData) {
                if ('service_url' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        if ($key == 'value') {
                            $service_url = $value;
                        }
                    }
                }
                $int++;
            }
            $url = $service_url;
            $url = $url . 'ejecutaInterfacesContables/list.json?id_mod=11&username=websafi&nitocc=800189921&id_username=946';
            //variables del debito
            //$fecha_proceso = $fecha_sistema;
            $id_mae_ter = 946;
            $mov_ejecutado = "Cesion-.-Cartera";
            $url = $url . '&fecha_proceso=' . $fecha_proceso;
            $url = $url . '&id_mae_ter=' . $id_mae_ter;
            $url = $url . '&mov_ejecutado=' . $mov_ejecutado;
            //$url = $url . '&id_movimiento=' . $id_cesion_cartera;
            $url = $url . '&tag_portal_web=1'; //facturas portal web - validar el retorno del json

            $ch = curl_init($url);

            //Parametros de retorno en cURL
            curl_setopt($ch, CURLOPT_HEADER, 0);
            $rta = curl_exec($ch);
            curl_close($ch);

            $arrayRespuesta = json_decode($rta, true);
            //Verifica el status, si es diferente de 0, ocurrio un error al subir la interfaz y debe reportarlo
            if ($arrayRespuesta['response']['status'] == 1) {
                $mensajeError = "Error :: Al generar la interfaz contable.";
                $this->status = 1;
                $this->list_data = array();
                $this->mensajeError = $mensajeError;
                $this->logMessage("[ca_cesion_cartera] " . $mensajeError);
            } else {
                $this->logMessage("[ca_cesion_cartera] Genero interfaz contable.");
            }

            $this->logMessage("FIN INTERFAZ CONTABLE CESION CARTERA");
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
